CREATE OR REPLACE
PROCEDURE EXP_REFORFIL_NGD
IS
  V_CHAVE           VARCHAR2(300);
  V_ERRO            VARCHAR2(300);
  V_CONTADOR        FLOAT := 0;
  V_VRLEADTIME      FLOAT := 0;
  V_QTMINAUTFOT     FLOAT := 0;
  V_VRLEADTIMEDESV  FLOAT := 0;
  V_CDFORNECED      FORNECEDOR.CDFORNECED%TYPE;
  V_CDFILIAL        FLOAT;
  V_CDMARCA_PADRAO  FLOAT;
  V_MAX_CDARVPROD   PRODUTO.CDARVPROD%TYPE;
BEGIN
   FOR C_FILIALOL IN
      (SELECT CDFILIAL CDFILIOPELOG, NMFILIAL, CDREGIAO
         FROM FILIAL
        WHERE NVL(FILIAL.IDCNTRRESC, 'N') <> 'S'
          AND NVL(FILIAL.IDFUNCAOFILI, 'T') = 'O'
          AND CDFILIAL NOT IN ('0003', '1010', '3801', '3802', '9793', '9891', 'C106'))
   LOOP
      FOR C_PRAZOFORNEXPEDFILPROD IN (SELECT PRODFORNCOMP.ROWID ROWID_COMP, PRAZOFORNEXPEDFILPROD.ROWID ROWID_EXPED
                                        FROM PRODFORNCOMP, PRODUTO PRODUTO_COMP, PRAZOFORNEXPEDFILPROD, PRODUTO PRODUTO_EXPED
                                       WHERE PRODFORNCOMP.CDPRODCOMPL = PRODUTO_COMP.CDPRODUTO
                                         AND PRAZOFORNEXPEDFILPROD.CDPRODUTO = PRODUTO_EXPED.CDPRODUTO
                                         AND PRODFORNCOMP.CDFORNECED =  PRAZOFORNEXPEDFILPROD.CDFORNECED
                                         AND PRODUTO_COMP.CDARVPROD LIKE PRODUTO_EXPED.CDARVPROD||'%'
                                         AND PRAZOFORNEXPEDFILPROD.CDFILIAL = C_FILIALOL.CDFILIOPELOG
                                         AND (NVL(PRAZOFORNEXPEDFILPROD.USR_NGD_INTEGRADO, 'N') = 'N')
                                         AND (NVL(PRODFORNCOMP.USR_NGD_INTEGRADO, 'N') = 'S')
                                         AND NOT EXISTS (SELECT 1
                                                           FROM REFOREG
                                                          WHERE REFOREG.CDREGIAO    = C_FILIALOL.CDREGIAO
                                                            AND REFOREG.CDFORNECED  = PRODFORNCOMP.CDFORNECED)
                                         AND NOT EXISTS (SELECT 1
                                                           FROM REFORFIL
                                                          WHERE REFORFIL.CDFILIAL    = C_FILIALOL.CDFILIOPELOG
                                                            AND REFORFIL.CDFORNECED  = PRODFORNCOMP.CDFORNECED
                                                            AND NVL(REFORFIL.CDPERIENTR, 'W') = 'W'))
      LOOP
         UPDATE PRODFORNCOMP
            SET PRODFORNCOMP.USR_NGD_INTEGRADO = 'N'
          WHERE PRODFORNCOMP.ROWID = C_PRAZOFORNEXPEDFILPROD.ROWID_COMP
            AND (NVL(PRODFORNCOMP.USR_NGD_INTEGRADO, 'N') = 'S');
         UPDATE PRAZOFORNEXPEDFILPROD
            SET PRAZOFORNEXPEDFILPROD.USR_NGD_INTEGRADO = 'S'
          WHERE PRAZOFORNEXPEDFILPROD.ROWID = C_PRAZOFORNEXPEDFILPROD.ROWID_EXPED
            AND (NVL(PRAZOFORNEXPEDFILPROD.USR_NGD_INTEGRADO, 'N') = 'N');
      END LOOP;
      FOR C_REFORFIL IN
         (SELECT C_FILIALOL.CDFILIOPELOG, MAX(PRODFORNCOMP.CDFORNECED) CDFORNECED, PRODUTOOL.CDARVPROD, 1 IDEMPRESADEST,
                 1 QTDEORIG, 1 QTDEDEST, 1 VRLEADTIMEDESV, CASE NVL(PRODFORNCOMP.VRARREDCMPFO, 0)
                                                              WHEN 0
                                                              THEN 1
                                                              ELSE NVL(PRODFORNCOMP.VRARREDCMPFO, 0)
                                                           END VRARREDCMPFO,
                 PRODUTO.CDPRODUTO, RELACPRODOL.CDPRODARVOL, RELACPRODOL.CDPRARVORIG, RELACPRODOL.CDMARCA,
                 PRODUTO.CDARVPROD CDARVPRODORIG
            FROM PRODUTO, RELACPRODOL, PRODUTO PRODUTOOL, PRODFORNCOMP, FORNECEDOR
           WHERE ((NVL(PRODUTO.IDPRODATIVPR, 'N')   <> 'N') OR (INSTR(PRODUTO.NMPRODUTO, 'INATIVO') = 0))
             AND ((NVL(PRODUTOOL.IDPRODATIVPR, 'N') <> 'N') OR (INSTR(PRODUTOOL.NMPRODUTO, 'INATIVO') = 0))
             AND PRODUTO.CDPRODESTO IS NOT NULL
             AND PRODUTO.CDPRODUTO       = RELACPRODOL.CDPRARVORIG
             AND PRODUTOOL.CDPRODUTO     = RELACPRODOL.CDPRODARVOL
             AND PRODUTO.CDPRODUTO       = PRODFORNCOMP.CDPRODCOMPL
             AND PRODFORNCOMP.CDFORNECED = FORNECEDOR.CDFORNECED
             AND ((NVL(PRODFORNCOMP.USR_NGD_INTEGRADO, 'N') = 'N')
              OR  (NVL(FORNECEDOR.USR_NGD_INTEGRADO_1, 'N') = 'N')
              OR  (NVL(RELACPRODOL.USR_NGD_INTEGRADO_1, 'N') = 'N')
              OR  (EXISTS (SELECT 1
                             FROM PRAZOFORNEXPEDFIL
                            WHERE PRAZOFORNEXPEDFIL.CDFORNECED = FORNECEDOR.CDFORNECED
                              AND PRAZOFORNEXPEDFIL.CDFILIAL   = C_FILIALOL.CDFILIOPELOG
                              AND (NVL(PRAZOFORNEXPEDFIL.USR_NGD_INTEGRADO, 'N') = 'N')
                            UNION
                           SELECT 1
                             FROM MINFORNREG
                            WHERE MINFORNREG.CDFORNECED = FORNECEDOR.CDFORNECED
                              AND MINFORNREG.CDREGIAO   = C_FILIALOL.CDREGIAO
                              AND (NVL(MINFORNREG.USR_NGD_INTEGRADO, 'N') = 'N')

                          )
                  )
                 )
             /*AND EXISTS (SELECT 1
                           FROM ITEMCOLE
                          WHERE ITEMCOLE.CDREGIAO    = C_FILIALOL.CDREGIAO
                            AND ITEMCOLE.CDFORNECED  = FORNECEDOR.CDFORNECED
                            AND ITEMCOLE.CDPRODUTO   = RELACPRODOL.CDPRARVORIG
                            --AND ITEMCOLE.CDMARCA     = RELACPRODOL.CDMARCA
                            AND ITEMCOLE.DTFINVALITM BETWEEN CASE
                                                                WHEN TRUNC(SYSDATE+1) >= LAST_DAY(TRUNC(SYSDATE))-5
                                                                THEN LAST_DAY(TRUNC(SYSDATE))+1
                                                                ELSE ADD_MONTHS((LAST_DAY(TRUNC(SYSDATE))+1), -1)
                                                             END  AND SYSDATE+999)*/
             AND NOT EXISTS (SELECT 1
                               FROM REFOREG
                              WHERE REFOREG.CDREGIAO    = C_FILIALOL.CDREGIAO
                                AND REFOREG.CDFORNECED  = FORNECEDOR.CDFORNECED)
             AND NOT EXISTS (SELECT 1
                               FROM REFORFIL
                              WHERE REFORFIL.CDFILIAL    = C_FILIALOL.CDFILIOPELOG
                                AND REFORFIL.CDFORNECED  = FORNECEDOR.CDFORNECED
                                AND NVL(REFORFIL.CDPERIENTR, 'W') = 'W')
           GROUP BY PRODUTOOL.CDARVPROD, CASE NVL(PRODFORNCOMP.VRARREDCMPFO, 0)
                                             WHEN 0
                                             THEN 1
                                             ELSE NVL(PRODFORNCOMP.VRARREDCMPFO, 0)
                                          END, PRODUTO.CDPRODUTO,
                    RELACPRODOL.CDPRODARVOL, RELACPRODOL.CDPRARVORIG, RELACPRODOL.CDMARCA, PRODUTO.CDARVPROD
             )
      LOOP
         SELECT COUNT(ITEMCOLE.CDFILIAL), NVL(MAX(FORNECEDOR.QTMINAUTFOT), 0), NVL(MAX(FORNECEDOR.CDFORNECED), C_REFORFIL.CDFORNECED)
           INTO V_CDFILIAL, V_QTMINAUTFOT, V_CDFORNECED
           FROM ITEMCOLE, FORNECEDOR
          WHERE ITEMCOLE.CDFORNECED  = FORNECEDOR.CDFORNECED
            AND ITEMCOLE.CDREGIAO    = C_FILIALOL.CDREGIAO
            AND ITEMCOLE.CDPRODUTO   = C_REFORFIL.CDPRARVORIG
            AND ITEMCOLE.CDMARCA     = C_REFORFIL.CDMARCA
            AND NVL(ITEMCOLE.VRPRECUNIITM, 0) > 0
            AND ITEMCOLE.DTFINVALITM BETWEEN CASE
                                                WHEN TRUNC(SYSDATE+1) >= LAST_DAY(TRUNC(SYSDATE))-5
                                                THEN LAST_DAY(TRUNC(SYSDATE))+1
                                                ELSE ADD_MONTHS((LAST_DAY(TRUNC(SYSDATE))+1), -1)
                                             END  AND SYSDATE+999;
         SELECT COUNT(1)
           INTO V_CDMARCA_PADRAO
           FROM RELACPRODOL, PRODUTO
          WHERE RELACPRODOL.CDPRODARVOL = PRODUTO.CDPRODUTO
            AND PRODUTO.CDARVPROD       = C_REFORFIL.CDARVPROD
            AND RELACPRODOL.CDMARCA     = '00000';
         IF ((V_CDFILIAL) = 0 AND (V_CDMARCA_PADRAO > 0))THEN
            SELECT COUNT(ITEMCOLE.CDFILIAL), NVL(MAX(FORNECEDOR.QTMINAUTFOT), 0), NVL(MAX(FORNECEDOR.CDFORNECED), C_REFORFIL.CDFORNECED)
              INTO V_CDFILIAL, V_QTMINAUTFOT, V_CDFORNECED
              FROM ITEMCOLE, FORNECEDOR
             WHERE ITEMCOLE.CDFORNECED  = FORNECEDOR.CDFORNECED
               AND ITEMCOLE.CDREGIAO    = C_FILIALOL.CDREGIAO
               AND ITEMCOLE.CDPRODUTO   = C_REFORFIL.CDPRARVORIG
               AND NVL(ITEMCOLE.VRPRECUNIITM, 0) > 0
               AND ITEMCOLE.DTFINVALITM BETWEEN CASE
                                                   WHEN TRUNC(SYSDATE+1) >= LAST_DAY(TRUNC(SYSDATE))-5
                                                   THEN LAST_DAY(TRUNC(SYSDATE))+1
                                                   ELSE ADD_MONTHS((LAST_DAY(TRUNC(SYSDATE))+1), -1)
                                                END   AND SYSDATE+999;
         END IF;
         IF V_CDFILIAL > 0 THEN
            V_CONTADOR := V_CONTADOR + 1;
            IF V_CONTADOR >= 500 THEN
               V_CONTADOR := 0;
               COMMIT;
            END IF;
            SELECT NVL(MAX(QTDIASPRAZOEXPED), 0)
              INTO V_VRLEADTIME
              FROM PRAZOFORNEXPEDFIL
             WHERE PRAZOFORNEXPEDFIL.CDFORNECED = V_CDFORNECED
               AND PRAZOFORNEXPEDFIL.CDFILIAL   = C_FILIALOL.CDFILIOPELOG;
            BEGIN
               SELECT NVL(MAX(PRODUTO.CDARVPROD), 'WWW')
                 INTO V_MAX_CDARVPROD
                 FROM PRODUTO, PRAZOFORNEXPEDFILPROD
                WHERE PRAZOFORNEXPEDFILPROD.CDPRODUTO  = PRODUTO.CDPRODUTO
                  AND PRAZOFORNEXPEDFILPROD.CDFORNECED = V_CDFORNECED
                  AND PRAZOFORNEXPEDFILPROD.CDFILIAL   = C_FILIALOL.CDFILIOPELOG
                  AND NVL(PRAZOFORNEXPEDFILPROD.QTDIASPRAZOEXPED, 0) > 0
                  AND (INSTR(C_REFORFIL.CDARVPRODORIG, PRODUTO.CDARVPROD) = 1);
            EXCEPTION
               WHEN OTHERS THEN BEGIN
                  V_MAX_CDARVPROD := 'WWW';
               END;
            END;
            IF V_MAX_CDARVPROD <> 'WWW' THEN
               SELECT NVL(MAX(PRAZOFORNEXPEDFILPROD.QTDIASPRAZOEXPED), V_VRLEADTIME)
                 INTO V_VRLEADTIME
                 FROM PRAZOFORNEXPEDFILPROD, PRODUTO
                WHERE PRAZOFORNEXPEDFILPROD.CDFILIAL   = C_FILIALOL.CDFILIOPELOG
                  AND PRAZOFORNEXPEDFILPROD.CDPRODUTO  = PRODUTO.CDPRODUTO
                  AND PRAZOFORNEXPEDFILPROD.CDFORNECED = V_CDFORNECED
                  AND PRODUTO.CDARVPROD                = V_MAX_CDARVPROD
                  AND NVL(PRAZOFORNEXPEDFILPROD.QTDIASPRAZOEXPED, 0) > 0;
            END IF;
            V_VRLEADTIMEDESV := 1;
            IF V_VRLEADTIME IS NULL THEN
               V_VRLEADTIME     := 1;
               V_VRLEADTIMEDESV := 1;
            ELSIF V_VRLEADTIME = 0 THEN
               V_VRLEADTIME     := 1;
               V_VRLEADTIMEDESV := 1;
            ELSE
               V_VRLEADTIMEDESV := CEIL(V_VRLEADTIME * 0.2);
            END IF;

            SELECT NVL(MAX(QTMINFORNREG), V_QTMINAUTFOT)
              INTO V_QTMINAUTFOT
              FROM MINFORNREG
             WHERE CDFORNECED = V_CDFORNECED
               AND CDREGIAO   = C_FILIALOL.CDREGIAO;
            BEGIN
               SELECT NVL(MAX(PRODUTO.CDARVPROD), 'WWW')
                 INTO V_MAX_CDARVPROD
                 FROM PRODUTO, PRAZOFORNEXPEDFILPROD
                WHERE PRAZOFORNEXPEDFILPROD.CDPRODUTO  = PRODUTO.CDPRODUTO
                  AND PRAZOFORNEXPEDFILPROD.CDFORNECED = V_CDFORNECED
                  AND PRAZOFORNEXPEDFILPROD.CDFILIAL   = C_FILIALOL.CDFILIOPELOG
                  AND NVL(PRAZOFORNEXPEDFILPROD.QTMINFORNREG, 0) > 0
                  AND (INSTR(C_REFORFIL.CDARVPRODORIG, PRODUTO.CDARVPROD) = 1);
            EXCEPTION
               WHEN OTHERS THEN BEGIN
                  V_MAX_CDARVPROD := 'WWW';
               END;
            END;
            IF V_MAX_CDARVPROD <> 'WWW' THEN
               SELECT NVL(MAX(PRAZOFORNEXPEDFILPROD.QTMINFORNREG), V_QTMINAUTFOT)
                 INTO V_QTMINAUTFOT
                 FROM PRAZOFORNEXPEDFILPROD, PRODUTO
                WHERE PRAZOFORNEXPEDFILPROD.CDFILIAL   = C_FILIALOL.CDFILIOPELOG
                  AND PRAZOFORNEXPEDFILPROD.CDPRODUTO  = PRODUTO.CDPRODUTO
                  AND PRAZOFORNEXPEDFILPROD.CDFORNECED = V_CDFORNECED
                  AND PRODUTO.CDARVPROD                = V_MAX_CDARVPROD
                  AND NVL(PRAZOFORNEXPEDFILPROD.QTMINFORNREG, 0) > 0;
            END IF;
            IF V_QTMINAUTFOT = 0 THEN
               V_QTMINAUTFOT := 0;
            END IF;

            SELECT NVL(MAX(USR_REFORFIL_NGD.CDFILIOPELOG), '')
              INTO V_CHAVE
              FROM USR_REFORFIL_NGD
             WHERE USR_REFORFIL_NGD.CDFILIOPELOG = C_FILIALOL.CDFILIOPELOG
               AND USR_REFORFIL_NGD.CDFORNECED   = V_CDFORNECED
               AND USR_REFORFIL_NGD.CDARVPROD    = C_REFORFIL.CDARVPROD;
            BEGIN
               IF V_CHAVE = '' THEN
                  INSERT
                   INTO USR_REFORFIL_NGD(CDFILIOPELOG, CDFORNECED, CDARVPROD, IDEMPRESADEST,
                                         QTDEORIG, QTDEDEST, VRLEADTIME, VRLEADTIMEDESV,
                                         QTMINAUTFOT, VRARREDCMPFO, IDSTATUSFORFIL,
                                         TPINTERFACE, DTINTERFACEORI,	DTINTERFACEDEST,	STATUS)
                  VALUES (C_FILIALOL.CDFILIOPELOG, V_CDFORNECED, C_REFORFIL.CDARVPROD, C_REFORFIL.IDEMPRESADEST,
                          C_REFORFIL.QTDEORIG, C_REFORFIL.QTDEDEST, V_VRLEADTIME, V_VRLEADTIMEDESV,
                          V_QTMINAUTFOT, C_REFORFIL.VRARREDCMPFO, 'ATIVO',	'I', 	SYSDATE,	NULL,	'1');
               ELSE
                  UPDATE USR_REFORFIL_NGD
                     SET VRLEADTIME         = V_VRLEADTIME,
                         VRLEADTIMEDESV     = V_VRLEADTIMEDESV,
                         QTMINAUTFOT        = V_QTMINAUTFOT,
                         VRARREDCMPFO       = C_REFORFIL.VRARREDCMPFO,
                         TPINTERFACE        = 'A',
                         DTINTERFACEORI     = SYSDATE,
                         DTINTERFACEDEST    = NULL,
                         STATUS             = '1'
                   WHERE USR_REFORFIL_NGD.CDFILIOPELOG = C_FILIALOL.CDFILIOPELOG
                     AND USR_REFORFIL_NGD.CDFORNECED   = V_CDFORNECED
                     AND USR_REFORFIL_NGD.CDARVPROD    = C_REFORFIL.CDARVPROD;
               END IF;
               UPDATE USR_LOG_NGD
                  SET DTLOG      = SYSDATE,
                      STATUS     = '0',
                      OBSSTATUS  = NULL
                WHERE IDPROCESSO = 'USR_REFORFIL_NGD'
                  AND IDPESQITEM = C_REFORFIL.CDFILIOPELOG||'-'||V_CDFORNECED||'-'||C_REFORFIL.CDARVPROD;
               IF SQL%NOTFOUND THEN
                 INSERT
                   INTO USR_LOG_NGD(IDPROCESSO, DTLOG, STATUS, OBSSTATUS, IDPESQITEM)
                 VALUES ('USR_REFORFIL_NGD', SYSDATE, '0', NULL, C_REFORFIL.CDFILIOPELOG||'-'||V_CDFORNECED||'-'||C_REFORFIL.CDARVPROD);
               END IF;
            EXCEPTION
               WHEN OTHERS THEN BEGIN
                  V_ERRO := SUBSTR(SQLERRM(SQLCODE), 1, 300);
                  UPDATE USR_LOG_NGD
                     SET DTLOG      = SYSDATE,
                         STATUS     = '1',
                         OBSSTATUS  = V_ERRO
                   WHERE IDPROCESSO = 'USR_REFORFIL_NGD'
                     AND IDPESQITEM = C_REFORFIL.CDFILIOPELOG||'-'||V_CDFORNECED||'-'||C_REFORFIL.CDARVPROD;
                  IF SQL%NOTFOUND THEN
                     INSERT
                       INTO USR_LOG_NGD(IDPROCESSO, DTLOG, STATUS, OBSSTATUS, IDPESQITEM)
                     VALUES ('USR_REFORFIL_NGD', SYSDATE, '1', V_ERRO, C_REFORFIL.CDFILIOPELOG||'-'||V_CDFORNECED||'-'||C_REFORFIL.CDARVPROD);
                  END IF;
               END;
            END;
         ELSE
            V_ERRO := 'Item sem tabela de preo ou com preo igual a zero.';
            UPDATE USR_LOG_NGD
               SET DTLOG      = SYSDATE,
                   STATUS     = '1',
                   OBSSTATUS  = V_ERRO
             WHERE IDPROCESSO = 'USR_REFORFIL_NGD'
               AND IDPESQITEM = C_REFORFIL.CDFILIOPELOG||'-'||V_CDFORNECED||'-'||C_REFORFIL.CDARVPROD;
            IF SQL%NOTFOUND THEN
               INSERT
                 INTO USR_LOG_NGD(IDPROCESSO, DTLOG, STATUS, OBSSTATUS, IDPESQITEM)
               VALUES ('USR_REFORFIL_NGD', SYSDATE, '1', V_ERRO, C_REFORFIL.CDFILIOPELOG||'-'||V_CDFORNECED||'-'||C_REFORFIL.CDARVPROD);
            END IF;
         END IF;
      END LOOP;
   END LOOP;

   /*ATUALIZA REGISTROS PARA NO SEREM INTEGRADOS NOVAMENTE*/
   FOR C_FILIALOL IN
      (SELECT CDFILIAL CDFILIOPELOG, NMFILIAL, CDREGIAO
         FROM FILIAL
        WHERE NVL(FILIAL.IDCNTRRESC, 'N') <> 'S'
          AND NVL(FILIAL.IDFUNCAOFILI, 'T') = 'O'
          AND CDFILIAL NOT IN ('0003', '1010', '3801', '3802', '9793', '9891', 'C106'))
   LOOP
      FOR C_REFORFIL IN
         (SELECT C_FILIALOL.CDFILIOPELOG, MAX(PRODFORNCOMP.CDFORNECED) CDFORNECED, PRODUTOOL.CDARVPROD, 1 IDEMPRESADEST,
                 1 QTDEORIG, 1 QTDEDEST, 1 VRLEADTIMEDESV, CASE NVL(PRODFORNCOMP.VRARREDCMPFO, 0)
                                                              WHEN 0
                                                              THEN 1
                                                              ELSE NVL(PRODFORNCOMP.VRARREDCMPFO, 0)
                                                           END VRARREDCMPFO,
                 PRODUTO.CDPRODUTO, RELACPRODOL.CDPRODARVOL, RELACPRODOL.CDPRARVORIG, RELACPRODOL.CDMARCA
            FROM PRODUTO, RELACPRODOL, PRODUTO PRODUTOOL, PRODFORNCOMP, FORNECEDOR
           WHERE ((NVL(PRODUTO.IDPRODATIVPR, 'N')   <> 'N') OR (INSTR(PRODUTO.NMPRODUTO, 'INATIVO') = 0))
             AND ((NVL(PRODUTOOL.IDPRODATIVPR, 'N') <> 'N') OR (INSTR(PRODUTOOL.NMPRODUTO, 'INATIVO') = 0))
             AND PRODUTO.CDPRODESTO IS NOT NULL
             AND PRODUTO.CDPRODUTO       = RELACPRODOL.CDPRARVORIG
             AND PRODUTOOL.CDPRODUTO     = RELACPRODOL.CDPRODARVOL
             AND PRODUTO.CDPRODUTO       = PRODFORNCOMP.CDPRODCOMPL
             AND PRODFORNCOMP.CDFORNECED = FORNECEDOR.CDFORNECED
             AND ((NVL(PRODFORNCOMP.USR_NGD_INTEGRADO, 'N') = 'N')
              OR  (NVL(FORNECEDOR.USR_NGD_INTEGRADO_1, 'N') = 'N')
              OR  (NVL(RELACPRODOL.USR_NGD_INTEGRADO_1, 'N') = 'N')
              OR  (EXISTS (SELECT 1
                             FROM PRAZOFORNEXPEDFIL
                            WHERE PRAZOFORNEXPEDFIL.CDFORNECED = FORNECEDOR.CDFORNECED
                              AND PRAZOFORNEXPEDFIL.CDFILIAL   = C_FILIALOL.CDFILIOPELOG
                              AND (NVL(PRAZOFORNEXPEDFIL.USR_NGD_INTEGRADO, 'N') = 'N')
                            UNION
                           SELECT 1
                             FROM MINFORNREG
                            WHERE MINFORNREG.CDFORNECED = FORNECEDOR.CDFORNECED
                              AND MINFORNREG.CDREGIAO   = C_FILIALOL.CDREGIAO
                              AND (NVL(MINFORNREG.USR_NGD_INTEGRADO, 'N') = 'N')

                          )
                  )
                 )
             /*AND EXISTS (SELECT 1
                           FROM ITEMCOLE
                          WHERE ITEMCOLE.CDREGIAO    = C_FILIALOL.CDREGIAO
                            AND ITEMCOLE.CDFORNECED  = FORNECEDOR.CDFORNECED
                            AND ITEMCOLE.CDPRODUTO   = RELACPRODOL.CDPRARVORIG
                            AND ITEMCOLE.CDMARCA     = RELACPRODOL.CDMARCA
                            AND ITEMCOLE.DTFINVALITM BETWEEN CASE
                                                                WHEN TRUNC(SYSDATE+1) >= LAST_DAY(TRUNC(SYSDATE))-5
                                                                THEN LAST_DAY(TRUNC(SYSDATE))+1
                                                                ELSE ADD_MONTHS((LAST_DAY(TRUNC(SYSDATE))+1), -1)
                                                             END  AND SYSDATE+999)*/

             AND NOT EXISTS (SELECT 1
                               FROM REFOREG
                              WHERE REFOREG.CDREGIAO    = C_FILIALOL.CDREGIAO
                                AND REFOREG.CDFORNECED  = FORNECEDOR.CDFORNECED)
           GROUP BY PRODUTOOL.CDARVPROD, CASE NVL(PRODFORNCOMP.VRARREDCMPFO, 0)
                                             WHEN 0
                                             THEN 1
                                             ELSE NVL(PRODFORNCOMP.VRARREDCMPFO, 0)
                                          END, PRODUTO.CDPRODUTO,
                    RELACPRODOL.CDPRODARVOL, RELACPRODOL.CDPRARVORIG, RELACPRODOL.CDMARCA)
      LOOP
         SELECT COUNT(ITEMCOLE.CDFILIAL), NVL(MAX(FORNECEDOR.QTMINAUTFOT), 0), NVL(MAX(FORNECEDOR.CDFORNECED), C_REFORFIL.CDFORNECED)
           INTO V_CDFILIAL, V_QTMINAUTFOT, V_CDFORNECED
           FROM ITEMCOLE, FORNECEDOR
          WHERE ITEMCOLE.CDFORNECED  = FORNECEDOR.CDFORNECED
            AND ITEMCOLE.CDREGIAO    = C_FILIALOL.CDREGIAO
            AND ITEMCOLE.CDPRODUTO   = C_REFORFIL.CDPRARVORIG
            AND ITEMCOLE.CDMARCA     = C_REFORFIL.CDMARCA
            AND NVL(ITEMCOLE.VRPRECUNIITM, 0) > 0
            AND ITEMCOLE.DTFINVALITM BETWEEN CASE
                                                WHEN TRUNC(SYSDATE+1) >= LAST_DAY(TRUNC(SYSDATE))-5
                                                THEN LAST_DAY(TRUNC(SYSDATE))+1
                                                ELSE ADD_MONTHS((LAST_DAY(TRUNC(SYSDATE))+1), -1)
                                             END  AND SYSDATE+999;
         SELECT COUNT(1)
           INTO V_CDMARCA_PADRAO
           FROM RELACPRODOL, PRODUTO
          WHERE RELACPRODOL.CDPRODARVOL = PRODUTO.CDPRODUTO
            AND PRODUTO.CDARVPROD       = C_REFORFIL.CDARVPROD
            AND RELACPRODOL.CDMARCA     = '00000';
         IF ((V_CDFILIAL) = 0 AND (V_CDMARCA_PADRAO > 0))THEN
            SELECT COUNT(ITEMCOLE.CDFILIAL), NVL(MAX(FORNECEDOR.QTMINAUTFOT), 0), NVL(MAX(FORNECEDOR.CDFORNECED), C_REFORFIL.CDFORNECED)
              INTO V_CDFILIAL, V_QTMINAUTFOT, V_CDFORNECED
              FROM ITEMCOLE, FORNECEDOR
             WHERE ITEMCOLE.CDFORNECED  = FORNECEDOR.CDFORNECED
               AND ITEMCOLE.CDREGIAO    = C_FILIALOL.CDREGIAO
               AND ITEMCOLE.CDPRODUTO   = C_REFORFIL.CDPRARVORIG
               AND NVL(ITEMCOLE.VRPRECUNIITM, 0) > 0
               AND ITEMCOLE.DTFINVALITM BETWEEN CASE
                                                   WHEN TRUNC(SYSDATE+1) >= LAST_DAY(TRUNC(SYSDATE))-5
                                                   THEN LAST_DAY(TRUNC(SYSDATE))+1
                                                   ELSE ADD_MONTHS((LAST_DAY(TRUNC(SYSDATE))+1), -1)
                                                END   AND SYSDATE+999;
         END IF;
         IF V_CDFILIAL > 0 THEN
            V_CONTADOR := V_CONTADOR + 1;
            IF V_CONTADOR >= 500 THEN
               V_CONTADOR := 0;
               COMMIT;
            END IF;
            UPDATE PRAZOFORNEXPEDFIL
               SET USR_NGD_INTEGRADO = 'S'
             WHERE PRAZOFORNEXPEDFIL.CDFORNECED = V_CDFORNECED
               AND PRAZOFORNEXPEDFIL.CDFILIAL   = C_FILIALOL.CDFILIOPELOG
               AND NVL(USR_NGD_INTEGRADO, 'N')  = 'N';
            UPDATE MINFORNREG
               SET USR_NGD_INTEGRADO = 'S'
             WHERE MINFORNREG.CDFORNECED       = V_CDFORNECED
               AND MINFORNREG.CDREGIAO         = C_FILIALOL.CDREGIAO
               AND NVL(USR_NGD_INTEGRADO, 'N') = 'N';
            UPDATE PRODFORNCOMP
               SET USR_NGD_INTEGRADO = 'S'
             WHERE PRODFORNCOMP.CDFORNECED       = V_CDFORNECED
               AND PRODFORNCOMP.CDPRODCOMPL      = C_REFORFIL.CDPRODUTO
               AND NVL(USR_NGD_INTEGRADO, 'N') = 'N';
            UPDATE FORNECEDOR
               SET USR_NGD_INTEGRADO_1 = 'S'
             WHERE FORNECEDOR.CDFORNECED       = V_CDFORNECED
               AND NVL(USR_NGD_INTEGRADO_1, 'N') = 'N';
            UPDATE RELACPRODOL
               SET USR_NGD_INTEGRADO_1 = 'S'
             WHERE RELACPRODOL.CDPRODARVOL       = C_REFORFIL.CDPRODARVOL
               AND NVL(USR_NGD_INTEGRADO_1, 'N') = 'N';
         END IF;
      END LOOP;
   END LOOP;
   COMMIT;

   /**********************************/
   /*
   V_CONTADOR  := 0;
   FOR C_ITEM IN(SELECT CODIGO_LOCAL_ESTOQUE CDFILIOPELOG, CNPJ CDFORNECED, CODIGO CDARVPROD, 1 IDEMPRESADEST,  LOTE_MINIMO QTMINAUTFOT,
                        1 QTDEORIG, 1 QTDEDEST, 1 VRARREDCMPFO, LEAD_TIME VRLEADTIME, VARIACAO_LT VRLEADTIMEDESV
                   FROM TAA_NGD_SKU )LOOP
      V_CONTADOR := V_CONTADOR + 1;
      IF V_CONTADOR >= 500 THEN
         V_CONTADOR := 0;
         COMMIT;
      END IF;
      UPDATE USR_REFORFIL_NGD
         SET VRLEADTIME         = C_ITEM.VRLEADTIME,
             VRLEADTIMEDESV     = C_ITEM.VRLEADTIMEDESV,
             QTMINAUTFOT        = C_ITEM.QTMINAUTFOT,
             VRARREDCMPFO       = C_ITEM.VRARREDCMPFO,
             TPINTERFACE        = 'A',
             DTINTERFACEORI     = SYSDATE,
             DTINTERFACEDEST    = NULL,
             STATUS             = '1'
       WHERE USR_REFORFIL_NGD.CDFILIOPELOG = C_ITEM.CDFILIOPELOG
         AND USR_REFORFIL_NGD.CDFORNECED   = C_ITEM.CDFORNECED
         AND USR_REFORFIL_NGD.CDARVPROD    = C_ITEM.CDARVPROD;
   END LOOP;
   COMMIT;
   */
   /**********************************/
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('EXP_REFORFIL_NGD','6.45.048'); END;
/
