<?php
namespace Teknisa\Model\Gestaopessoas\Repositories;

use HCM\Util\Repositories;
use Geral\Util\DateUtil;

class FpaValorreferenciam extends \Doctrine\ORM\EntityRepository {
    
    
    public function retornaValorReferencia($nrOrg, $nrOrgPadrao, $dtmesCompetenc, $nomevalorreferencia=null){
        
        $params = array('p_nrorg' => $nrOrg, 'p_nrorg_padrao' => $nrOrgPadrao, 'p_dtmescompetenc' => $dtmesCompetenc, 'p_dsreferencia' => $nomevalorreferencia);
        $fpa_valorReferenciam = Repositories::FPA_VALORREFERENCIAM;
        $fpa_valorReferenciah = Repositories::FPA_VALORREFERENCIAH;
        
$sql = <<<SQL
    SELECT r, h FROM $fpa_valorReferenciam r
        JOIN $fpa_valorReferenciah h 
        WITH r.nrvalorreferenciam = h.nrvalorreferenciam
        and h.dtmescompetenc = 
            (SELECT MAX(hh.dtmescompetenc) FROM $fpa_valorReferenciah hh 
                        where hh.nrvalorreferenciam = h.nrvalorreferenciam
                              and hh.dtmescompetenc <= :p_dtmescompetenc)
        WHERE (r.nrorg = :p_nrorg or r.nrorg = :p_nrorg_padrao)
        AND (r.dsreferencia = :p_dsreferencia OR :p_dsreferencia is null)
SQL;

        return $this->getEntityManager()->createQuery($sql)->execute($params);  
    }
    
    public function buscavalor($nrOrg, $nrOrgPadrao, $dtmesCompetenc, $nomevalorreferencia){
        
        $params = array('p_nrorg' => $nrOrg, 'p_nrorg_padrao' => $nrOrgPadrao, 'p_dtmescompetenc' => $dtmesCompetenc, 'p_dsreferencia' => $nomevalorreferencia);    
        $fpa_valorReferenciam = Repositories::FPA_VALORREFERENCIAM;
        $fpa_valorReferenciah = Repositories::FPA_VALORREFERENCIAH;
        
$sql = <<<SQL
    SELECT r, h FROM $fpa_valorReferenciam r
        JOIN $fpa_valorReferenciah h 
        WITH r.nrvalorreferenciam = h.nrvalorreferenciam
        AND h.vrreferencia > 0
        AND h.nrorg = r.nrorg
        AND h.dtmescompetenc = 
            (SELECT MAX(hh.dtmescompetenc) FROM $fpa_valorReferenciah hh 
                        where hh.nrvalorreferenciam = h.nrvalorreferenciam
                              and hh.nrorg = h.nrorg
                              and hh.dtmescompetenc <= :p_dtmescompetenc)
        WHERE (r.nrorg = :p_nrorg or r.nrorg = :p_nrorg_padrao)
        AND r.dsreferencia = :p_dsreferencia
SQL;
        $result =  $this->getEntityManager()->createQuery($sql)->execute($params);
        if(count($result) > 0){
            $resultado = array();
            foreach ($result as $key => $valor) {
                if($valor instanceof $fpa_valorReferenciam){
                    $valor->historico = $result[$key+1];
                    $resultado[] = $valor;
                }    
            }
            return $resultado[0]->historico->getVrreferencia();
        }
        
        return null;
    }
    
    
}